## libcrush 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(libcrush)
set(VERSION 1.0.0)

set(CMAKE_C_FLAGS_NONE "${CMAKE_C_FLAGS_NONE} -Wall -O2 -g")

include_directories(${CMAKE_SOURCE_DIR}/crush)
include_directories(${CMAKE_BINARY_DIR}/crush)

include(CheckIncludeFiles)

CHECK_INCLUDE_FILES("inttypes.h" HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES("stdint.h" HAVE_STDINT_H)
CHECK_INCLUDE_FILES("linux/types.h" HAVE_LINUX_TYPES_H)

configure_file(
  ${CMAKE_SOURCE_DIR}/crush/config-h.in.cmake
  ${CMAKE_BINARY_DIR}/crush/acconfig.h
)

add_custom_target(doc
  ALL
  COMMAND : \; \( cat doc/Doxygen \; echo 'OUTPUT_DIRECTORY = ${CMAKE_BINARY_DIR}/doc' \) | doxygen -
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
install(FILES ${CMAKE_BINARY_DIR}/doc/man/man3/API.3 RENAME libcrush.3 DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man3/)

set(crush_srcs
  crush/builder.c
  crush/mapper.c
  crush/crush.c
  crush/hash.c)

set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH "libdir")
set(CMAKE_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include CACHE PATH "includedir")
set(CMAKE_INSTALL_DATADIR ${CMAKE_INSTALL_PREFIX}/share CACHE PATH "datadir")

add_library(crush SHARED ${crush_srcs})
set_target_properties(crush PROPERTIES
    VERSION 1.0.0
    SOVERSION 1
    )
install(TARGETS crush DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY crush DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} FILES_MATCHING PATTERN "*.h")
install(FILES ${CMAKE_BINARY_DIR}/crush/acconfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/crush/)

configure_file(
  ${CMAKE_SOURCE_DIR}/libcrush.pc.in
  ${CMAKE_BINARY_DIR}/libcrush.pc
  @ONLY
)
install(FILES ${CMAKE_BINARY_DIR}/libcrush.pc DESTINATION ${CMAKE_INSTALL_DATADIR}/pkgconfig/)

add_subdirectory(test)
add_subdirectory(googletest)
enable_testing()

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${VERSION})
add_custom_target(dist
  COMMAND git-archive-all/git-archive-all.sh --format tar.gz --prefix ${CMAKE_PROJECT_NAME}-${VERSION}/ ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}-${VERSION}.tar.gz
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== test/CMakeLists.txt ===
enable_testing()

set(UNITTEST_CXX_FLAGS "-I${CMAKE_SOURCE_DIR}/googletest/googlemock/include -I${CMAKE_BINARY_DIR}/googletest/googlemock/include -I${CMAKE_SOURCE_DIR}/googletest/googletest/include -I${CMAKE_BINARY_DIR}/googletest/googletest/include -fno-strict-aliasing")

add_executable(unittest_builder test_builder.cc)
set_target_properties(unittest_builder PROPERTIES COMPILE_FLAGS ${UNITTEST_CXX_FLAGS})
target_link_libraries(unittest_builder crush gtest gtest_main)
add_test(builder unittest_builder)

=== debian/changelog ===
libcrush (1.0.0-8) unstable; urgency=medium

  * autopkgtest run depends on libc-dev

 -- Loic Dachary (OuoU) <loic@debian.org>  Sun, 12 Feb 2017 23:19:34 +0100

libcrush (1.0.0-7) unstable; urgency=medium

  * autopkgtest should ignore stderr
  * patches: cannonical manpage name

 -- Loic Dachary (OuoU) <loic@debian.org>  Sun, 12 Feb 2017 18:33:47 +0100

libcrush (1.0.0-6) unstable; urgency=medium

  * autopkgtest run depends on libc-dev

 -- Loic Dachary (OuoU) <loic@debian.org>  Sun, 12 Feb 2017 00:43:06 +0100

libcrush (1.0.0-5) unstable; urgency=medium

  * autopkgtest run depends on libcrush-dev

 -- Loic Dachary (OuoU) <loic@debian.org>  Sat, 11 Feb 2017 21:45:55 +0100

libcrush (1.0.0-4) unstable; urgency=medium

  * autopkgtest run depends on pkg-config

 -- Loic Dachary (OuoU) <loic@debian.org>  Sat, 11 Feb 2017 16:54:01 +0100

libcrush (1.0.0-3) unstable; urgency=medium

  * autopkgtest depends on gcc
  * update Standards-Version to 3.9.8

 -- Loic Dachary (OuoU) <loic@debian.org>  Sat, 11 Feb 2017 13:53:39 +0100

libcrush (1.0.0-2) unstable; urgency=medium

  * add missing copyright attribution (Closes: #854831).

 -- Loic Dachary (OuoU) <loic@debian.org>  Sat, 11 Feb 2017 00:15:47 +0100

libcrush (1.0.0-1) unstable; urgency=low

  * Initial release
  * Closes: #854045

 -- Loic Dachary (OuoU) <loic@debian.org>  Mon, 30 Jan 2017 00:22:32 +0200

=== debian/control ===
Source: libcrush
Priority: optional
Section: devel
Maintainer: Loic Dachary (OuoU) <loic@debian.org>
Build-Depends: debhelper (>= 10.0.0), cmake, doxygen
Standards-Version: 3.9.8

Package: libcrush-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libcrush1 (= ${binary:Version}), pkg-config
Description: C library to control placement in a hierarchy development files
 libcrush maps an object signature to a list of devices on which to
 store the object. It is implemented as a pseudo-random, deterministic
 function obeying user specified placement constraints such as: the
 object must be stored on devices that are on two different machines.

Package: libcrush1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C library to control placement in a hierarchy
 libcrush maps an object signature to a list of devices on which to
 store the object. It is implemented as a pseudo-random, deterministic
 function obeying user specified placement constraints such as: the
 object must be stored on devices that are on two different machines.

=== debian/tests/control ===
Tests: run-example
Depends: libcrush-dev, libc-dev, gcc
Restrictions: allow-stderr
